
#ifndef ROOT_TBranchObject
#define ROOT_TBranchObject

//+SEQ,CopyRight,T=NOINCLUDE.

//////////////////////////////////////////////////////////////////////////
//                                                                      //
// TBranchObject                                                        //
//                                                                      //
// A Branch for the case of an object.                                  //
//////////////////////////////////////////////////////////////////////////


#ifndef ROOT_TBranch
//*KEEP,TBranch,T=C++.
#include "TBranch.h"
//*KEND.
#endif

class TBranchObject : public TBranch {

protected:
    TString     fClassName;        //Class name of referenced object
    TObject     *fOldObject;       //!Pointer to old object

public:
    TBranchObject();
    TBranchObject(const Text_t *name, const Text_t *classname, void *addobj, Int_t basketsize=32000, Int_t splitlevel = 0, Int_t compress=-1);
    virtual ~TBranchObject();

    virtual void    Browse(TBrowser *b);
    virtual Int_t   Fill();
    virtual Int_t   GetEntry(Int_t entry=0);
    Bool_t          IsFolder();
    virtual void    Print(Option_t *option="");
    virtual void    Reset(Option_t *option="");
    virtual void    SetAddress(void *addobj);
    virtual void    SetBasketSize(Int_t buffsize);
    virtual void    UpdateAddress();

    ClassDef(TBranchObject,1)  //Branch in case of an object
};

#endif
